/**
 * File Storage API
 * Use the File Storage service API to manage file systems, mount targets, and snapshots.
For more information, see [Overview of File Storage](/iaas/Content/File/Concepts/filestorageoverview.htm).

 * OpenAPI spec version: 20171215
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary information for the LDAP bind account used by the outbound connector.
 *
 */
export interface LdapBindAccountSummary extends model.OutboundConnectorSummary {
    /**
     * Array of server endpoints to use when connecting with the LDAP bind account.
     *
     */
    "endpoints": Array<model.Endpoint>;
    /**
     * The LDAP Distinguished Name of the account.
     */
    "bindDistinguishedName": string;
    "connectorType": string;
}
export declare namespace LdapBindAccountSummary {
    function getJsonObj(obj: LdapBindAccountSummary, isParentJsonObj?: boolean): object;
    const connectorType = "LDAPBIND";
    function getDeserializedJsonObj(obj: LdapBindAccountSummary, isParentJsonObj?: boolean): object;
}
